
var settings = {
	extactive: true,
	invertonly: false
};

var blacklist = ["10.r3.at","anilinkz.to","aphokmecjbcmanljldfpicppmlakkojj","app.noiiz.com","bbc.github.io","beta.speedtest.net","blenderartists.org","blog.tljhgame.com","blog.zodiac.vc","boards.na.leagueoflegends.com","c1.staticflickr.com","calf-studio-gear.org","caolanm.blogspot.de","ccdirectlink.github.io","cgcookie.com","codepen.io","codepen.io","color.adobe.com","cross-code.com","crosscode.gamepedia.com","dhs.nu","discordapp.com","dmp3download.com","emcarroll.com","ffmpeg.org","flowartstation.com","focusrite.de","forum.cross-code.com","forum.paradoxplaza.com","forum.scssoft.com","freewheeling.sourceforge.net","ftbwiki.org","gamejolt.com","gaming.youtube.com","gtlive.info","heilig.berlin","hitomi.la","hmc-soundcheck.blogspot.de","hollowknight.com","ichun.me","imgur.com","inspirobot.me","int10h.org","intonarumori.sourceforge.net","jackbox.tv","jonivoid.bandcamp.com","kommwohnen.de","kxstudio.linuxaudio.org","labs.phaser.io","lazyfoo.net","leveluplinux.blogspot.de","mcs.franknora.com","mididee.blogspot.de","mienfield.com","minecraftbuildcraft.wikia.com","morecss.org","musescore.com","newtab","picarto.tv","pigeonsandplanes.com","play.spotify.com","player.vimeo.com","protomusic.wordpress.com","proxer.de","proxer.me","qjackctl.sourceforge.io","qmidiarp.sourceforge.net","qsampler.sourceforge.io","qsynth.sourceforge.io","qube-game.com","s.codepen.io","sig-ex.com","softpixel.com","ssj71.github.io","starbounder.org","steamcommunity.com","steampowered.com","store.playstation.com","store.steampowered.com","tapclaim.com","tljhgame.com","tmate.io","tour.ubuntu.com","tour.ubuntuusers.de","upload.wikimedia.org","virtualplaying.com","webapp.kaufda.de","wowwiki.wikia.com","www.6by9.net","www.a1k0n.net","www.adobe.com","www.aixfoam.com","www.auralex.com","www.beatport.com","www.best-free-vst.com","www.bibliocraftmod.com","www.couchconnection.de","www.creativeshrimp.com","www.cupoflinux.com","www.daedalic.de","www.devdungeon.com","www.ev3dev.org","www.fontsquirrel.com","www.hammersound.net","www.hoerspielprojekt.de","www.lifeinthewoods.ca","www.litterati.org","www.little-nightmares.com","www.photopea.com","www.playdead.com","www.podcastthemes.com","www.radicalfishgames.com","www.robotvirtualworlds.com","www.roguefx.com","www.schristiancollins.com","www.singlecellsoftware.com","www.square-enix.co.jp","www.stanleyparable.com","www.stevenhoneyman.co.uk","www.strawpoll.me","www.technicpack.net","www.theaudioarchive.com","www.toxicgames.co.uk","www.tracktion.com","www.ultimate-guitar.com","www.upworldthegame.com","www.wintergatan.net"];
var rules = [
	/*{
		host: null,
		path: null,
		active: true,
		css: [
			{
				selector: '',
				properties: [
					{
						name: '',
						value: ''
					}
				]
			}
		]
	}*/
	{
		host: null,
		path: null,
		active: true,
		css: [
			{
				selector: 'html, img, video, svg, iframe, frame, [wotsearchtarget]',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate('+ /*calc(*/ 'var(--hue)'+ /** 1)*/ ')'
					}
				]
			},
			{
				selector: 'html',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate('+ /*calc(*/ 'var(--hue)'+ /** -1)*/ ')'
					},
					{
						name: 'background',
						value: 'var(--htmlbg) !important'
					}
				]
			},
			{
				selector: ':-webkit-full-screen-ancestor:not(iframe) *',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			}
		]
	},
	{
		host: null,
		path: null,
		active: true,
		css: [
			{
				selector: '.stefanvdlightareoff',
				properties: [
					{
						name: 'background',
						value: '#fff !important'
					}
				]
			}
		]
	},
	{
		host: /^extensions-frame$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.extension-list-item, .extension-list-item > *',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue)) !important'
					}
				]
			}
		]
	},
	{
		host: /^www\.youtube\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'ytd-masthead#masthead',
				properties: [
					{
						name: '--yt-swatch-primary',
						value: 'rgb(255,255,255) !important'
					},
					{
						name: '--yt-swatch-primary-darker',
						value: 'rgb(230,230,230) !important'
					},
					{
						name: '--yt-swatch-text',
						value: 'rgba(17,17,17,.4) !important'
					},
					{
						name: '--yt-swatch-input-text',
						value: 'rgba(17,17,17,1) !important'
					},
					{
						name: '--yt-swatch-textbox-bg',
						value: 'rgba(255,255,255,1) !important'
					},
					{
						name: '--yt-swatch-icon-color',
						value: 'rgba(136,136,136,1) !important'
					}
				]
			},
			{
				selector: '#scrim.app-drawer',
				properties: [
					{
						name: 'background',
						value: 'rgba(255,255,255,.5)'
					}
				]
			},
			{
				selector: '.watch-stage-mode #theater-background',
				properties: [
					{
						name: 'background',
						value: '#fff !important'
					}
				]
			},
			{
				selector: '.html5-video-player, :-webkit-full-screen-ancestor:not(iframe), #player-playlist, .yt-pl-thumb, span.video-time, ytd-masthead#masthead > #ticker, #overlays',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.html5-video-player *, .ytp-fullscreen, .yt-pl-thumb img, yt-icon svg, ytd-masthead#masthead > #ticker *, #overlays *',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			},
			{
				selector: '#player-container.ytd-watch, ytd-watch.loading-player #player.ytd-watch',
				properties: [
					{
						name: 'background-color',
						value: '#fff'
					}
				]
			},
			{
				selector: '#remind-me-later-button.ytd-consent-bump-renderer',
				properties: [
					{
						name: '--yt-button-color',
						value: 'var(--yt-swatch-important-text)'
					}
				]
			}
		]
	},
	{
		host: /twitter\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.gallery-overlay, .PermalinkOverlay-with-background, .modal-overlay',
				properties: [
					{
						name: 'background',
						value: 'rgba(230,230,230,0.7) !important'
					},
				]
			},
			{
				selector: '.Gallery-media',
				properties: [
					{
						name: 'background',
						value: '#000 !important'
					}
				]
			},
			/*{
				selector: '.tweet .with-icn .Icon, .ProfileTweet-action--retweet:hover .ProfileTweet-actionButton, .ProfileTweet-action--favorite:hover .ProfileTweet-actionButton, .ProfileTweet-action--retweet .ProfileTweet-actionButtonUndo, .ProfileTweet-action--favorite .ProfileTweet-actionButtonUndo',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},*/
			{
				selector: 'tcu-imageWrapper, .tcu-imageWrapper, .gallery-enabled .Gallery, .PlayableMedia-player, .all-controls, .EmojiPicker-item',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: 'tcu-imageWrapper *, .tcu-imageWrapper *, .gallery-enabled .Gallery *, .PlayableMedia-player iframe, .PlayableMedia-player video, .PlayableMedia-reactWrapper svg, .EmojiPicker-item *',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			}
		]
	},
	{
		host: /twitter\.com$/,
		path: /^\/i\/videos\/.*/,
		active: false,
		css: [
			{
				selector: 'html',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			}
		]
	},
	{
		host: /twitter\.com$/,
		path: /^\/i\/videos\/.*/,
		active: false,
		css: []
	},
	{
		host: /^vid\.me$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.header:not(.opaque) *, .header_gutter, .cover, .thumb_img, .player, .video-js, #embed_view, .icon, .user_photo, .splash_inner, span.logo-black, #index .featured_users ul > li > a, #index .featured_users ul > li > a > *, #media .colors .color-block',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.header:not(.opaque) > * *, .header_gutter *, .cover *, .thumb_img *, .player *, .video-js *, #embed_view *, .icon *, .user_photo *, .splash_inner *, .feature_icon svg, span.logo-black *, #index .featured_users ul > li > a > * *',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			},
			{
				selector: '.header',
				properties: [
					{
						name: 'background-color',
						value: 'rgba(255,255,255,0.5)'
					}
				]
			},
			{
				selector: '.header.opaque',
				properties: [
					{
						name: 'background-color',
						value: '#fff'
					}
				]
			},
			{
				selector: '.modal-backdrop.in',
				properties: [
					{
						name: 'background-color',
						value: '#ddd'
					}				]
			},
			{
				selector: '#media .colors .color-block',
				properties: [
					{
						name: 'border',
						value: '1px solid #fff'
					}
				]
			},
			{
				selector: '#user_view .avatar a.edit-avatar-link',
				properties: [
					{
						name: 'color',
						value: '#333'
					}
				]
			},
			{
				selector: '#user_view .avatar a.edit-avatar-link:hover',
				properties: [
					{
						name: 'color',
						value: '#000'
					}
				]
			}
		]
	},
	{
		host: /^docs\.vid\.me$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'pre',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					},
					{
						name: 'border-color',
						value: '#444'
					}

				]
			},
			{
				selector: 'pre *',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /www\.facebook\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '._3qx ._3ixn',
				properties: [
					{
						name: 'background',
						value: 'rgba(255,255,255,0.9) !important'
					}
				]
			},
			{
				selector: '._4-hy ._3ixn',
				properties: [
					{
						name: 'background',
						value: 'rgba(255,255,255,0.4) !important'
					}
				]
			},
			{
				selector: '._4d3w .stageWrapper, ._3u13 ._3u15',
				properties: [
					{
						name: 'background',
						value: '#fff !important'
					}
				]
			},
			{
				selector: '._3tsq._3htz, span._iuw, .UFICommentReactionIconContainer, span._3t54 > a > span, ._1ktw, ._5r8i, i.img, ._3x-2 [role="presentation"], ._3x-2 [display="inline"]',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '._-kb ._3x-2 [role="presentation"]',
				properties: [
					{
						name: 'filter',
						value: 'none'
					}
				]
			}
		]
	},
	{
		host: /..*\.wikipedia\.org$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'body.mw-mmv-lightbox-open > .mw-mmv-overlay',
				properties: [
					{
						name: 'background-color',
						value: '#fff'
					}
				]
			},
			{
				selector: '.mw-mmv-next-image, .mw-mmv-prev-image',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: 'img.mwe-math-fallback-image-inline',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			}
		]
	},
	{
		host: /^drive\.google\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.l-u-Ab-zb-Ua',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			},
			{
				selector: '.a-b-L, .a-b-Ia',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			}
		]
	},
	{
		host: /^docs\.google\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.docs-homescreen-fcc-inlinecontainer.docs-homescreen-fcc-inlinecontainer-docked, .docs-homescreen-fcc-flex.docs-homescreen-fcc-flex-contracted > .docs-homescreen-fcc-nav, span.gb_8a.gbii',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.picker-iframe.picker-white-callout.picker-minew .picker-min-frame-up',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /^soundcloud\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.header, .dropdownMenu, .image > .sc-artwork, compactTrackListItem__image > .sc-artwork, .commentForm__avatar > .sc-artwork, .coverArt__infoItem, .sc-button-play, .sc-button-pause, .sc-button-prev, .sc-button-next, .sc-button.sc-button-blocked, .sc-button.sc-button-play:disabled, .sc-button.sc-button-play:disabled:hover, .sc-button.sc-button-play.sc-button-disabled:disabled',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.header *',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			},
			{
				selector: '.image__whiteOutline .image__full',
				properties: [
					{
						name: 'border',
						value: '2px solid #000 !important'
					}
				]
			}
		]
	},
	{
		host: /^(www|go)\.twitch\.tv$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'html:not(.theme--dark) nav.top-nav, html:not(.theme--dark) .theme--dark, .card__meta, .c-text-overlay',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: 'html:not(.theme--dark) nav.top-nav *, html.theme--dark, [data-reactroot].theme--dark *, .theme--dark img, .theme--dark video, .theme--dark svg, .theme--dark iframe, .theme--dark frame, .theme--dark [wotsearchtarget], .card__meta *, .theme--dark .card__meta, .c-text-overlay *',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			}
		]
	},
	{
		host: /^www\.instagram\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '._sppa1, ._si7dy',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '._ea084',
				properties: [
					{
						name: 'background',
						value: 'rgba(255,255,255,.75) !important'
					}
				]
			}
		]
	},
	{
		host: /bandcamp\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.bcdaily-thumb-img, .img, .carousel-bcweekly-container-container, .notable .playvid-btn, .notable .playvid-time, .has-hover .item-link.playable > span > span',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.bcdaily-thumb-img *, .img *, .carousel-bcweekly-container-container *',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /\.bandcamp\.com$/,
		path: null,
		active: true,
		css: [
			/*{
				selector: '',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},*/
			{
				selector: 'div.stats-graph-container > svg',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /^stackoverflow\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.topbar, #footer, .badge-container, .topbar-dialog',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.topbar *, #footer *',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /^askubuntu\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.topbar, #header, .badge-container, .topbar-dialog',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.topbar *, #header *',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /^(www\.amazon\.com\.au|www\.amazon\.com\.br|www\.amazon\.ca|www\.amazon\.cn|www\.amazon\.fr|www\.amazon\.de|www\.amazon\.in|www\.amazon\.it|www\.amazon\.co\.jp|www\.amazon\.com\.mx|www\.amazon\.nl|www\.amazon\.es|www\.amazon\.co\.uk|www\.amazon\.com)$/,
		path: null,
		active: true,
		css: [
			{
				selector: '#navFooter, div.profile-image',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: 'iframe#product-description-iframe',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /^www\.draw\.io$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'html *',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			}
		]
	},
	{
		host: /^www\.wolframalpha\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'img.ng-isolate-scope',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			}
		]
	},
	{
		host: /^streamcloud\.eu$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'div#mediaplayer',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.jwvideo video',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /^www\.mp4upload\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.jwplayer',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.jwvideo video',
				properties: [
					{
						name: 'filter',
						value: 'initial'
					}
				]
			}
		]
	},
	{
		host: /.*\.slack\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.client_channels_list_container, .member_preview_link, nav#site_nav, figure.image_bg, figure.msg_inline_img.msg_inline_child, .presence i.presence_icon, span.emoji-sizer, span.emoji-wrapper, span.member_image, .team_icon, #fs_modal.prefs_modal #prefs_themes .theme_thumb',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.client_channels_list_container *, nav#site_nav, figure.image_bg *, figure.msg_inline_img.msg_inline_child *',
				properties: [
					{
						name: 'filter',
						value: 'initial !important'
					}
				]
			},
			{
				selector: 'ts-jumper',
				properties: [
					{
						name: 'background',
						value: 'rgba(255,255,255,0.7) !important'
					}
				]
			}
		]
	},
	{
		host: /^css-tricks\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'pre',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					},
					{
						name: 'background',
						value: 'rgba(20,20,20,.85) !important'
					}
				]
			}
		]
	},
	{
		host: /^www\.dropbox\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '#modal-overlay, .db-modal-overlay',
				properties: [
					{
						name: 'background',
						value: 'rgba(219,216,213,.6)'
					}
				]
			}
		]
	},
	{
		host: /^www\.ted\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.Flex-embed__content--cover',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue))'
					}
				]
			},
			{
				selector: '.player-hero, .player-hero__banner',
				properties: [
					{
						name: 'background',
						value: '#fff'
					}
				]
			}
		]
	},
	{
		host: /^toggl\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.splash',
				properties: [
					{
						name: 'background',
						value: '#fff'
					}
				]
			},
			{
				selector: '.left-nav',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue)) !important'
					}
				]
			}
		]
	},
	{
		host: /^www\.iflscience\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: 'article .image-wrap img.lazyloaded',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue)) !important'
					}
				]
			}
		]
	},
	{
		host: /^onedrive\.live\.com$/,
		path: null,
		active: true,
		css: [
			{
				selector: '.od-ImageFrame',
				properties: [
					{
						name: 'filter',
						value: 'invert(var(--invert)) hue-rotate(var(--hue)) !important'
					}
				]
			}
		]
	}
];
/*
var iframed = {
	top: undefined,
	parent: undefined
};
*/

var s = undefined;

var storage = chrome.storage.sync;

storage.get(['settings','blacklist','rules'], function(items){
	if (!items) {
		items = {};
	}
	if (items.settings) {
		settings = items.settings;
	} else {
		storage.set({'settings': settings}, function() {});
	}
	if (!items.blacklist) {
		storage.set({'blacklist': blacklist}, function() {});
		items.blacklist = blacklist;
	}
	if (!items.rules) {
		storage.set({'rules': rules}, function() {});
		items.rules = rules;
	}
	if (settings.extactive === true) {
		if (items.blacklist && items.blacklist.length > 0) {
			blacklist = items.blacklist;
		}
		if (items.rules && items.rules.length > 0) {
			rules = items.rules;
		}
		toggle();
	}
});

chrome.storage.onChanged.addListener(function(changes) {
	if (changes.settings) {
		settings = changes.settings.newValue;
	}
	if (changes.blacklist) {
		blacklist = changes.blacklist.newValue;
	}
	if (changes.rules) {
		rules = changes.rules.newValue;
	}
	toggle();
});


function toggle() {
	var inv = (location.host !== '' && blacklist.indexOf((location.host == 'www.google.de' && location.pathname == '/_/chrome/newtab' ? 'newtab' : location.host)) === -1 && settings.extactive);
	var hue = (location.host !== '' && blacklist.indexOf((location.host == 'www.google.de' && location.pathname == '/_/chrome/newtab' ? 'newtab' : location.host)) === -1 && !settings.invertonly && settings.extactive);

	var cssvars = '--invert: '+ (inv ? '1' : '0') +'; --hue: '+ (hue ? '180' : '0') +'deg; --htmlbg: '+ (inv ? '#000' : 'default') +';';
	//console.log('cssvars '+cssvars);
	if (s) {
		s.sheet.cssRules[0].style.cssText = cssvars;
	} else {
		s = document.createElement('style');
		s.appendChild(document.createTextNode('')); // webkit hack
		//document.head.appendChild(s);
		document.documentElement.appendChild(s);
		s.sheet.insertRule(':root {'+cssvars+'}', s.sheet.cssRules.length);
	//	if (/*!iframed.parent ||*/ blacklist.indexOf(window.parent.location.host) !== -1) {
	/*		s.sheet.insertRule('html, img, video, svg, iframe, frame, [wotsearchtarget] {filter: invert(var(--invert)) hue-rotate(var(--hue));}', s.sheet.cssRules.length);
			//setTimeout(function(){s.sheet.cssRules[1].style.cssText += ' transition: filter 300ms ease-out;';}, 1000);
			s.sheet.insertRule('html {filter: invert(var(--invert)) hue-rotate(calc(var(--hue) * -1)); background: var(--htmlbg) !important;}', s.sheet.cssRules.length);
		} else {
			s.sheet.insertRule('img, video, svg, [wotsearchtarget] {filter: invert(var(--invert)) hue-rotate(var(--hue));}', s.sheet.cssRules.length);
		}
		s.sheet.insertRule('.stefanvdlightareoff {background: #fff !important;}', s.sheet.cssRules.length);
		s.sheet.insertRule(':-webkit-full-screen-ancestor:not(iframe) * {filter: initial !important;}', s.sheet.cssRules.length);
	*/
		if (document.contentType == 'application/pdf' || (document.contentType == 'application/octet-stream' && /\.pdf$/i.test(location.pathname))) {
			// no access to native pdf viewer, embedded as plugin
			// no access to PDF.js either, because chrome-extension:// protocol
			// :-(
	/*	} else if (location.host == 'extensions-frame') {
			s.sheet.insertRule('.extension-list-item, .extension-list-item > * {filter: invert(var(--invert)) hue-rotate(var(--hue));}', s.sheet.cssRules.length);
	*/	} else {

			/************ dynamic rewrite ***************/

			foreach(rules, function(rule) {
				if (typeof(rule.host) === 'string') {
					rule.host = new RegExp(rule.host.slice(0,-1));
				}
				if (rule.active && (!rule.host || rule.host.test(location.host)) && (!rule.path || rule.path.test(location.pathname))) {
					foreach(rule.css, function(selector) {
						var res = selector.selector + ' {';
						foreach(selector.properties, function(properties) {
							res += properties.name + ': ' + properties.value + '; ';
						});

						try {
							s.sheet.insertRule(res + '}', s.sheet.cssRules.length);
						} catch (e) {
							console.log(e);
							console.log(res+'}, '+s.sheet.cssRules.length);
						}
					});
				}
			});
		}
	}

	return s;
}

function foreach(obj, cb) {
	if (obj.constructor === Array) {
		for (var i = 0; i < obj.length; i++) {
			//alert(i+' / '+obj.length+' : '+JSON.stringify(obj[i]));
			cb(obj[i], i);
		}
	} else if (typeof obj === 'object') {
		for (var p in obj) {
			cb(obj[p], p);
		}
	} else {
		cb(undefined, null);
		return false;
	}
}
